local addonName, L  = ...;
local frameTypesToHide = {};

function ArenaLive_BlizzFrameHider_AddFrame(frame)
	
	if ( not frame ) then
		return;
	end
	
	local frameName;
	local varType = type(frame);

	if ( varType == "table" ) then
		frameName = frame:GetName();
	elseif ( varType == "string" ) then
		frameName = frame;
		frame = _G[frameName];
	end
	
	frameTypesToHide[frameName] = true;
	ArenaLive_BlizzFrameHider_HideFrame(frame);
end

function ArenaLive_BlizzFrameHider_RemoveFrame(frame)

	if ( not frame ) then
		return;
	end

	local frameName;
	local varType = type(blizzFrame);

	if ( varType == "table" ) then
		frameName = frame:GetName();
	elseif ( varType == "string" ) then
		frameName = frame;
		frame = _G[frameName];
	end

	frameTypesToHide[frameName] = nil;
end

function ArenaLive_BlizzFrameHider_Refresh()

	for key, value in pairs(frameTypesToHide) do
		if ( value ) then
			ArenaLive_BlizzFrameHider_HideFrame(key)
		end
	end

end

function ArenaLive_BlizzFrameHider_HideFrame(frame)

	if ( not frame ) then
		return;
	end

	local frameName;
	local varType = type(blizzFrame);

	if ( varType == "table" ) then
		frameName = frame:GetName();
	elseif ( varType == "string" ) then
		frameName = frame;
		frame = _G[frameName];
	end
	
	if ( frameName ~= "PlayerFrame" ) then
		frame:UnregisterAllEvents();
		frame.Show = function() end;
	end
		
	frame:Hide();

end

function ArenaLive_BlizzFrameHider_CheckHiddenStatus(frame)

	if ( not frame ) then
		return;
	end

	local varType = type(frame);

	if ( varType == "table" ) then
		frameName = frame:GetName();
	elseif ( varType == "string" ) then
		frameName = frame;
		frame = _G[frameName];
	end
	
	if ( frameTypesToHide[frameName] ) then
		return true;
	else
		return false;
	end
end