-- HEALTHPREDICTIONBAR
local MAX_INCOMING_HEAL_OVERFLOW = 1.0;
function ArenaLive_HealPredictionBar_Update (unitFrame)

	if ( not unitFrame.healPredictionBar or not unitFrame.healthBar ) then
		return;
	end	
	
	if ( not unitFrame.unit ) then
		unitFrame.healPredictionBar:Hide();
		return;
	end
	
	if ( not ARENALIVE_DATABASE[unitFrame.addonName]["options"]["showHealPrediction"] or not unitFrame.unit ) then
		unitFrame.healPredictionBar:Hide();
		return;
	else
		
		local predictedHeal = UnitGetIncomingHeals(unitFrame.unit) or 0;
	
		local health = UnitHealth(unitFrame.unit);
		local maxHealth = UnitHealthMax(unitFrame.unit);
		local relativeTo;
		
		if ( health + predictedHeal > maxHealth * MAX_INCOMING_HEAL_OVERFLOW ) then
			predictedHeal = maxHealth * MAX_INCOMING_HEAL_OVERFLOW - health;
		end
		
		if ( predictedHeal == 0 ) then
			unitFrame.healPredictionBar:Hide();
		else
			unitFrame.healPredictionBar:ClearAllPoints();

			if ( unitFrame.healthBar:GetReverseFill() ) then
				unitFrame.healPredictionBar:SetPoint("TOPRIGHT", unitFrame.healthBar:GetStatusBarTexture(), "TOPLEFT", 0, 0);
			else
				unitFrame.healPredictionBar:SetPoint("TOPLEFT", unitFrame.healthBar:GetStatusBarTexture(), "TOPRIGHT", 0, 0);
			end

			local totalWidth, totalHeight = unitFrame.healthBar:GetSize();
			local _, totalMax = unitFrame.healthBar:GetMinMaxValues();

			local barWidth = (predictedHeal / totalMax) * totalWidth;
			unitFrame.healPredictionBar:SetSize(barWidth, totalHeight);
			unitFrame.healPredictionBar:Show();	
		end
	end
end