local addonName, L = ...;
-- STATUSBAR TEXT
function ArenaLive_StatusBarText_SetStatusBarTextString (statusBar, fontString)

	statusBar.text = fontString;

end


local match, replace;
function ArenaLive_StatusBarText_UpdateText (statusBar, statusBarTextTemplate, minValue, maxValue, value)

	if ( not statusBar.text or not minValue or not maxValue or not value ) then
		return;
	end

	local percent = ( value / maxValue ) * 100;
	
	if ( statusBar.unit and ( UnitIsDead(statusBar.unit) or UnitIsGhost(statusBar.unit) ) and statusBar.showDeadorGhostText ) then
		
		if ( UnitIsDead(statusBar.unit) ) then
			statusBar.text:SetText(DEAD);
		else
			
			statusBar.text:SetText(L["ghost"]);
		end
	elseif ( statusBar.unit and statusBar.showDeadorGhostText and not UnitIsConnected(statusBar.unit) ) then
		if ( UnitExists(statusBar.unit) ) then
			statusBar.text:SetText(L["disconnected"]);
		else
			statusBar.text:SetText("");
		end
	
	elseif ( ( (value > 0 ) or ( value == 0 and statusBar.alwaysShowText ) ) and ( not statusBar.forceHideText ) ) then
		
		match = string.find(statusBarTextTemplate, "%%CURR%%");
		
		if ( match ) then
			replace = BreakUpLargeNumbers(value);
			statusBarTextTemplate = string.gsub(statusBarTextTemplate, "%%CURR%%", replace);
			match = nil;
		end

		match = string.find(statusBarTextTemplate, "%%CURR_SHORT%%");
		if ( match ) then
			replace = AbbreviateLargeNumbers(value)
			statusBarTextTemplate = string.gsub(statusBarTextTemplate, "%%CURR_SHORT%%", replace);
			match = nil;
		end
	
		match = string.find(statusBarTextTemplate, "%%MAX%%");
		if ( match ) then
			replace = BreakUpLargeNumbers(maxValue);
			statusBarTextTemplate = string.gsub(statusBarTextTemplate, "%%MAX%%", replace);
			match = nil;
		end

		match = string.find(statusBarTextTemplate, "%%MAX_SHORT%%");
		if ( match ) then
			replace = AbbreviateLargeNumbers(maxValue)
			statusBarTextTemplate = string.gsub(statusBarTextTemplate, "%%MAX_SHORT%%", replace);
			match = nil;
		end
	
		match = string.find(statusBarTextTemplate, "%%PERCENT%%");
		if ( match ) then
			replace = BreakUpLargeNumbers(percent);
			statusBarTextTemplate = string.gsub(statusBarTextTemplate, "%%PERCENT%%", replace);
			match = nil;
		end
	
		match = string.find(statusBarTextTemplate, "%%PERCENT_SHORT%%");
		if ( match ) then
			replace = math.ceil(percent);
			statusBarTextTemplate = string.gsub(statusBarTextTemplate, "%%PERCENT_SHORT%%", replace);
			match = nil;
		end	

		match = string.find(statusBarTextTemplate, "%%ABSORB%%");
		
		if ( match ) then
			local absorbAmount = UnitGetTotalAbsorbs(statusBar.unit) or 0;
			if ( absorbAmount == 0 ) then
				replace = "";
			else
				replace = "(+"..AbbreviateLargeNumbers(absorbAmount)..")";
			end
			statusBarTextTemplate = string.gsub(statusBarTextTemplate, "%%ABSORB%%", replace);
			match = nil;
		end

		statusBar.text:SetText(statusBarTextTemplate);
		
	elseif ( value == 0 ) and ( statusBar.zeroText ) and ( not statusBar.forceHideText ) then
	
		statusBar.text:SetText(statusBar.zeroText);
	
	else
		statusBar.text:SetText("");
	end

end