local addonName, L = ...;
local wasInitialsed = false;

function ALUF_OptionsPartyFrames_OnLoad(self)
	-- Create a sub panel in ArenaLiveUnitFrame addon panel
	self.name= L["partyFrames"];
	self.okay = ALUF_OptionsPartyFrames_Okay;
	self.cancel = ALUF_OptionsPartyFrames_Cancel;
	self.parent = "ArenaLiveUnitFrames";
	InterfaceOptions_AddCategory(self);	

	local prefix = self:GetName();
	self.iCBlocker = _G[prefix.."InCombatLockDownBlocker"];
	_G[prefix.."InCombatLockDownBlockerText"]:SetText(L["inCombatLockdown"]);	
	
	-- Set Localisation:
	ALUF_PartyFrames_OptionsTitle:SetText(L["ALUFPartyFramesTitle"]);
	ALUF_PartyFrames_OptionsCastBarTitle:SetText(L["castBar:"]);
	ALUF_PartyFrames_OptionsAuraTitle:SetText(L["auras:"]);
	
	--self:RegisterEvent("ADDON_LOADED");
end

function ALUF_OptionsPartyFrames_Initialise(self)
	local prefix = self:GetName();
	local checkbutton, editbox, slider, dropdown, selectedValue;
	
	-- Initialise Checkbuttons
	checkbutton = _G[prefix.."IsEnabled"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "enableFrame", "partyFrames", nil, "enabled");
	
	checkbutton = _G[prefix.."IsLocked"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "lockFrame", "partyFrames", nil, "isLocked");

	checkbutton = _G[prefix.."GrowUpwards"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "growFramesUpwards", "partyFrames", nil, "growUpwards");	

	checkbutton = _G[prefix.."ShowInRaid"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showInRaid", "partyFrames", nil, "showInRaid");

	checkbutton = _G[prefix.."ShowInArena"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showInArena", "partyFrames", nil, "showInArena");

	checkbutton = _G[prefix.."ShowPlayer"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showPlayer", "partyFrames", nil, "showPlayer");	
	
	checkbutton = _G[prefix.."ShowTarget"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showpartyTargets", "partyFrames", "targetFrame", "isShown");

	checkbutton = _G[prefix.."ShowPetFrame"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showpartyPets", "partyFrames", "petFrame", "isShown");
	
	checkbutton = _G[prefix.."ShowCastBar"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showCastbar", "partyFrames", "castBar", "isShown");

	checkbutton = _G[prefix.."ShowCastHistory"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showCastHistory", "partyFrames", "castHistory", "isShown");	

	checkbutton = _G[prefix.."ShowAuras"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showAuras", "partyFrames", "auraFrame", "isShown");
	
	checkbutton = nil;
	
	
	-- Initialise Editboxes
	editbox = _G[prefix.."HealthBarText"];
	ALUF_Options_EditBoxInitialise(editbox, "shownTextinHealthBar:", "partyFrames", nil, "healthBarTextString");

	editbox = _G[prefix.."PowerBarText"];
	ALUF_Options_EditBoxInitialise(editbox, "shownTextinPowerBar:", "partyFrames", nil, "powerBarTextString");
	
	-- Initialise Sliders
	slider = _G[prefix.."FrameScale"];
	slider.valueFactor = 0.1;
	ALUF_Options_SliderInitialise(slider, "frameScale", "partyFrames", nil, "scale");

	slider = _G[prefix.."CastHistoryShownIcons"];
	ALUF_Options_SliderInitialise(slider, "maxCastHistoryIcons", "partyFrames", "castHistory", "shownIcons");	
	
	slider = _G[prefix.."CastHistoryIconSize"];
	ALUF_Options_SliderInitialise(slider, "castHistoryIconSize", "partyFrames", "castHistory", "iconSize");
	
	slider = _G[prefix.."NormalAuraIconSize"];
	ALUF_Options_SliderInitialise(slider, "normalAuraIconSize", "partyFrames", "auraFrame", "iconSize");

	slider = _G[prefix.."LargeAuraIconSize"];
	ALUF_Options_SliderInitialise(slider, "largeAuraIconSize", "partyFrames", "auraFrame", "largeIconSize");
	
	slider = _G[prefix.."FrameSpacing"];
	ALUF_Options_SliderInitialise(slider, "spaceBetweenFrames", "partyFrames", nil, "frameSpacing");

	slider = _G[prefix.."MaxShownBuffs"];
	ALUF_Options_SliderInitialise(slider, "maxShownBuffs", "partyFrames", "auraFrame", "maxShownBuffs");

	slider = _G[prefix.."MaxShownDebuffs"];
	ALUF_Options_SliderInitialise(slider, "maxShownDebuffs", "partyFrames", "auraFrame", "maxShownDebuffs");
	
	slider = nil;
	
	-- Initialise DropDown menus
	dropdown = _G[prefix.."PortraitType"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["portraitType"];
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = _G[prefix.."Icon1"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["icon1Type"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);

	dropdown = _G[prefix.."Icon2"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["icon2Type"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);

	dropdown = _G[prefix.."HealthBarColour"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["healthBarColourMode"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);

	dropdown = _G[prefix.."NameColour"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["nameColourMode"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);

	dropdown = _G[prefix.."TargetPosition"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["targetFrame"]["position"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);

	dropdown = _G[prefix.."PetFramePosition"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["petFrame"]["position"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = _G[prefix.."CastBarPosition"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castBar"]["position"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = _G[prefix.."AuraPosition"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["position"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = nil;
end

function ALUF_OptionsPartyFrames_OnEvent(self, event, ...)
	local arg1 = ...;
	
	if ( event == "ADDON_LOADED" and arg1 == addonName ) then
		ALUF_OptionsPartyFrames_Initialise(self)
	end

end

function ALUF_OptionsPartyFrames_OnShow(self)

	if ( not wasInitialsed ) then
		ALUF_OptionsPartyFrames_Initialise(self)
		wasInitialsed = true;
	end

	if ( InCombatLockdown() ) then
		self.iCBlocker:Show();
	else
		self.iCBlocker:Hide();
	end
end


function ALUF_OptionsPartyFrames_Okay(self)
	local prefix = self:GetName();
	local frame;
	if ( not InCombatLockdown() and wasInitialsed ) then
		-- CHECKBUTTONS
		frame = _G[prefix.."IsEnabled"];
		--[[ We need to check, if we have to reload the UI here, because we taint the Blizz frame in the reactivation process.
		Once the UI is reloaded, the Blizz frame shouldn't be taitned anymore because then we don't try to hide him. ]]--
		ALUF_Options_CheckNeedUIReload("partyFrames", frame:GetChecked());
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["enabled"] = frame:GetChecked();
		
		frame = _G[prefix.."IsLocked"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["isLocked"] = frame:GetChecked();

		frame = _G[prefix.."GrowUpwards"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["growUpwards"] = frame:GetChecked();

		frame = _G[prefix.."ShowInRaid"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["showInRaid"] = frame:GetChecked();		

		frame = _G[prefix.."ShowInArena"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["showInArena"] = frame:GetChecked();			

		frame = _G[prefix.."ShowPlayer"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["showPlayer"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowTarget"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["targetFrame"]["isShown"] = frame:GetChecked();

		frame = _G[prefix.."ShowPetFrame"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["petFrame"]["isShown"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowCastBar"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castBar"]["isShown"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowCastHistory"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castHistory"]["isShown"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowAuras"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["isShown"] = frame:GetChecked();
		
		-- EDITBOXES
		frame = _G[prefix.."HealthBarText"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["healthBarTextString"] = frame:GetText();
		
		frame = _G[prefix.."PowerBarText"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["powerBarTextString"] = frame:GetText();
		
		
		-- SLIDERS
		frame = _G[prefix.."FrameScale"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["scale"] = ALUF_Options_SliderGetValue(frame);
		
		frame = _G[prefix.."CastHistoryShownIcons"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castHistory"]["shownIcons"] = ALUF_Options_SliderGetValue(frame);

		frame = _G[prefix.."CastHistoryIconSize"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castHistory"]["iconSize"] = ALUF_Options_SliderGetValue(frame);

		frame = _G[prefix.."NormalAuraIconSize"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["iconSize"] = ALUF_Options_SliderGetValue(frame);

		frame = _G[prefix.."LargeAuraIconSize"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["largeIconSize"] = ALUF_Options_SliderGetValue(frame);
		
		frame = _G[prefix.."FrameSpacing"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["frameSpacing"] = ALUF_Options_SliderGetValue(frame);
		
		frame = _G[prefix.."MaxShownBuffs"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["maxShownBuffs"] = ALUF_Options_SliderGetValue(frame);

		frame = _G[prefix.."MaxShownDebuffs"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["maxShownDebuffs"] = ALUF_Options_SliderGetValue(frame);		
		
		-- DROPDOWN MENUS
		frame = _G[prefix.."PortraitType"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["portraitType"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."Icon1"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["icon1Type"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."Icon2"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["icon2Type"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."HealthBarColour"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["healthBarColourMode"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."NameColour"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["nameColourMode"] = UIDropDownMenu_GetSelectedValue(frame);

		frame = _G[prefix.."TargetPosition"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["targetFrame"]["position"] = UIDropDownMenu_GetSelectedValue(frame);

		frame = _G[prefix.."PetFramePosition"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["petFrame"]["position"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."CastBarPosition"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castBar"]["position"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."AuraPosition"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["position"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = nil;
		
		-- Updapte the frame and saved variables
		ArenaLive_Database_UpdateSavedVariables(addonName, ArenaLiveUnitFrames_SavedVariables);
		
		local enabled = ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["enabled"];
		
		-- Hide Blizzard Frame if needed
		if ( enabled and not ArenaLive_BlizzFrameHider_CheckHiddenStatus("PartyMemberFrame1")) then
			ArenaLive_BlizzFrameHider_AddFrame(PartyMemberFrame1);
			ArenaLive_BlizzFrameHider_AddFrame(PartyMemberFrame2);
			ArenaLive_BlizzFrameHider_AddFrame(PartyMemberFrame3);
			ArenaLive_BlizzFrameHider_AddFrame(PartyMemberFrame4);
		end	
		
		ALUF_PartyFrames_OnEvent(ALUF_PartyFrames, "GROUP_ROSTER_UPDATE", "lol");
		ALUF_PartyFrames_UpdateOptions(ALUF_PartyFrames);
		
	end
end



function ALUF_OptionsPartyFrames_Cancel(self)
	
	local prefix = self:GetName();
	local frame;
	if ( not InCombatLockdown() ) then	
		-- CHECKBUTTONS
		frame = _G[prefix.."IsEnabled"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["enabled"]);
		
		frame = _G[prefix.."IsLocked"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["isLocked"]);

		frame = _G[prefix.."GrowUpwards"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["growUpwards"]);

		frame = _G[prefix.."ShowInRaid"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["showInRaid"]);
		
		frame = _G[prefix.."ShowInArena"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["showInArena"]);		

		frame = _G[prefix.."ShowPlayer"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["showPlayer"]);		
		
		frame = _G[prefix.."ShowTarget"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["targetFrame"]["isShown"]);
		
		frame = _G[prefix.."ShowPetFrame"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["petFrame"]["isShown"]);
		
		frame = _G[prefix.."ShowCastBar"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castBar"]["isShown"]);
		
		frame = _G[prefix.."ShowCastHistory"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castHistory"]["isShown"]);
		
		frame = _G[prefix.."ShowAuras"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["isShown"]);
		
		
		-- EDITBOXES
		frame = _G[prefix.."HealthBarText"];
		frame:SetText(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["healthBarTextString"]);
		
		frame = _G[prefix.."PowerBarText"];
		frame:SetText(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["powerBarTextString"]);
		
		
		-- SLIDERS
		frame = _G[prefix.."FrameScale"];
		ALUF_Options_SliderSetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["scale"]);
			
		frame = _G[prefix.."CastHistoryShownIcons"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castHistory"]["shownIcons"]);
			
		frame = _G[prefix.."CastHistoryIconSize"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castHistory"]["iconSize"]);

		frame = _G[prefix.."NormalAuraIconSize"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["iconSize"]);

		frame = _G[prefix.."LargeAuraIconSize"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["largeIconSize"]);

		frame = _G[prefix.."FrameSpacing"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["frameSpacing"]);

		frame = _G[prefix.."MaxShownBuffs"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["maxShownBuffs"]);

		frame = _G[prefix.."MaxShownDebuffs"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["maxShownDebuffs"]);		
		
		-- DROPDOWN MENUS
		frame = _G[prefix.."PortraitType"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["portraitType"]);
		
		frame = _G[prefix.."Icon1"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["icon1Type"]);
		
		frame = _G[prefix.."Icon2"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["icon2Type"]);
		
		frame = _G[prefix.."HealthBarColour"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["healthBarColourMode"]);
		
		frame = _G[prefix.."NameColour"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["nameColourMode"]);

		frame = _G[prefix.."TargetPosition"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["targetFrame"]["position"]);

		frame = _G[prefix.."PetFramePosition"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["petFrame"]["position"]);
		
		frame = _G[prefix.."CastBarPosition"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["castBar"]["position"]);
		
		frame = _G[prefix.."AuraPosition"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["partyFrames"]["auraFrame"]["position"]);
		
		frame = nil;
	end
end