local addonName, L = ...;
local wasInitialsed = false;
function ALUF_OptionsPetFrame_OnLoad(self)
	-- Create a sub panel in ArenaLiveUnitFrame addon panel
	self.name= L["petFrame"];
	self.okay = ALUF_OptionsPetFrame_Okay;
	self.cancel = ALUF_OptionsPetFrame_Cancel;
	self.parent = "ArenaLiveUnitFrames";
	InterfaceOptions_AddCategory(self);	

	local prefix = self:GetName();
	self.iCBlocker = _G[prefix.."InCombatLockDownBlocker"];
	_G[prefix.."InCombatLockDownBlockerText"]:SetText(L["inCombatLockdown"]);	
	
	-- Set Localisation:
	ALUF_PetFrame_OptionsTitle:SetText(L["ALUFPetFrameTitle"]);
	ALUF_PetFrame_OptionsCastBarTitle:SetText(L["castBar:"]);
	ALUF_PetFrame_OptionsAuraTitle:SetText(L["auras:"]);
	
	--self:RegisterEvent("ADDON_LOADED");
end

function ALUF_OptionsPetFrame_Initialise(self)
	local prefix = self:GetName();
	local checkbutton, editbox, slider, dropdown, selectedValue;
	
	-- Initialise Checkbuttons
	checkbutton = _G[prefix.."IsEnabled"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "enableFrame", "petFrame", nil, "enabled");
	
	checkbutton = _G[prefix.."IsLocked"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "lockFrame", "petFrame", nil, "isLocked");
	
	checkbutton = _G[prefix.."ShowCastBar"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showCastbar", "petFrame", "castBar", "isShown");	

	checkbutton = _G[prefix.."ShowAuras"];
	ALUF_Options_CheckButtonInitialise(checkbutton, "showAuras", "petFrame", "auraFrame", "isShown");
	
	checkbutton = nil;
	
	
	-- Initialise Editboxes
	editbox = _G[prefix.."HealthBarText"];
	ALUF_Options_EditBoxInitialise(editbox, "shownTextinHealthBar:", "petFrame", nil, "healthBarTextString");

	editbox = _G[prefix.."PowerBarText"];
	ALUF_Options_EditBoxInitialise(editbox, "shownTextinPowerBar:", "petFrame", nil, "powerBarTextString");
	
	-- Initialise Sliders
	slider = _G[prefix.."FrameScale"];
	slider.valueFactor = 0.1;
	ALUF_Options_SliderInitialise(slider, "frameScale", "petFrame", nil, "scale");

	slider = _G[prefix.."NormalAuraIconSize"];
	ALUF_Options_SliderInitialise(slider, "normalAuraIconSize", "petFrame", "auraFrame", "iconSize");

	slider = _G[prefix.."LargeAuraIconSize"];
	ALUF_Options_SliderInitialise(slider, "largeAuraIconSize", "petFrame", "auraFrame", "largeIconSize");
	
	slider = nil;
	
	-- Initialise DropDown menus
	dropdown = _G[prefix.."HealthBarColour"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["healthBarColourMode"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = _G[prefix.."CastBarPosition"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["castBar"]["position"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = _G[prefix.."AuraPosition"];
	selectedValue = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["position"];	
	UIDropDownMenu_Initialize(dropdown, ALUF_Options_DropDownInitialise);
	UIDropDownMenu_SetSelectedValue(dropdown, selectedValue, false);
	
	dropdown = nil;
end

function ALUF_OptionsPetFrame_OnShow(self)

	if ( not wasInitialsed ) then
		ALUF_OptionsPetFrame_Initialise(self)
		wasInitialsed = true;
	end

	if ( InCombatLockdown() ) then
		self.iCBlocker:Show();
	else
		self.iCBlocker:Hide();
	end
end


function ALUF_OptionsPetFrame_Okay(self)
	local prefix = self:GetName();
	local frame;
	
	if ( not InCombatLockdown() and wasInitialsed ) then
		-- CHECKBUTTONS
		frame = _G[prefix.."IsEnabled"];
		--[[ We need to check, if we have to reload the UI here, because we taint the Blizz frame in the reactivation process.
		Once the UI is reloaded, the Blizz frame shouldn't be taitned anymore because then we don't try to hide him. ]]--
		ALUF_Options_CheckNeedUIReload("petFrame", frame:GetChecked());
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["enabled"] = frame:GetChecked();
		
		frame = _G[prefix.."IsLocked"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["isLocked"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowCastBar"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["castBar"]["isShown"] = frame:GetChecked();
		
		frame = _G[prefix.."ShowAuras"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["isShown"] = frame:GetChecked();
		
		
		-- EDITBOXES
		frame = _G[prefix.."HealthBarText"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["healthBarTextString"] = frame:GetText();
		
		frame = _G[prefix.."PowerBarText"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["powerBarTextString"] = frame:GetText();
		
		
		-- SLIDERS
		frame = _G[prefix.."FrameScale"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["scale"] = ALUF_Options_SliderGetValue(frame);

		frame = _G[prefix.."NormalAuraIconSize"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["iconSize"] = ALUF_Options_SliderGetValue(frame);

		frame = _G[prefix.."LargeAuraIconSize"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["largeIconSize"] = ALUF_Options_SliderGetValue(frame);
		
		
		-- DROPDOWN MENUS		
		frame = _G[prefix.."HealthBarColour"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["healthBarColourMode"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."CastBarPosition"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["castBar"]["position"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = _G[prefix.."AuraPosition"];
		ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["position"] = UIDropDownMenu_GetSelectedValue(frame);
		
		frame = nil;
		
		-- Updapte the frame and saved variables
		ArenaLive_Database_UpdateSavedVariables(addonName, ArenaLiveUnitFrames_SavedVariables);
		
		local scale = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["scale"];
		local enabled = ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["enabled"];
		
		-- Hide Blizzard Frame if needed
		if ( enabled and not ArenaLive_BlizzFrameHider_CheckHiddenStatus(PetFrame)) then
			ArenaLive_BlizzFrameHider_AddFrame(PetFrame);
		end	
		
		ALUF_PetFrame:SetScale(scale);
		ArenaLive_UnitFrame_Update(ALUF_PetFrame);
		ALUF_PetFrame_AdjustAttachments(ALUF_PetFrame);
	end
end



function ALUF_OptionsPetFrame_Cancel(self)
	
	local prefix = self:GetName();
	local frame;
	if ( not InCombatLockdown() ) then	
		-- CHECKBUTTONS
		frame = _G[prefix.."IsEnabled"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["enabled"]);
		
		frame = _G[prefix.."IsLocked"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["isLocked"]);
		
		frame = _G[prefix.."ShowCastBar"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["castBar"]["isShown"]);
		
		frame = _G[prefix.."ShowAuras"];
		frame:SetChecked(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["isShown"]);
		
		
		-- EDITBOXES
		frame = _G[prefix.."HealthBarText"];
		frame:SetText(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["healthBarTextString"]);
		
		frame = _G[prefix.."PowerBarText"];
		frame:SetText(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["powerBarTextString"]);
		
		
		-- SLIDERS
		frame = _G[prefix.."FrameScale"];
		ALUF_Options_SliderSetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["scale"]);

		frame = _G[prefix.."NormalAuraIconSize"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["iconSize"]);

		frame = _G[prefix.."LargeAuraIconSize"];
		frame:SetValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["largeIconSize"]);
		
		
		-- DROPDOWN MENUS
		frame = _G[prefix.."HealthBarColour"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["healthBarColourMode"]);

		frame = _G[prefix.."CastBarPosition"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["castBar"]["position"]);
		
		frame = _G[prefix.."AuraPosition"];
		UIDropDownMenu_SetSelectedValue(ARENALIVE_DATABASE[addonName]["frameTypes"]["petFrame"]["auraFrame"]["position"]);
		
		frame = nil;
	end
end